--巅峰战斗录像列表
Lua_PeakDuelFightDetailsWindow = class("Lua_PeakDuelFightDetailsWindow", Lua_Window)
function Lua_PeakDuelFightDetailsWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_PeakDuelFightDetailsWindow"
	self.skinName = "PeakDuelFightDetailsWindow_skin"
    self.showBlackMask = true
    self.isClickClose = true
    self:addPreLoadRes("/images/peakDuel/xui_dfs_bg_5.png", Lua_LoadFileType.IMG)
end

function Lua_PeakDuelFightDetailsWindow:buildShowItem()
	self:superCall("buildShowItem")

	self:addLuaEvent("PEAK_DUEL_FIGHT_DETAILS", self, self.onFightDetails)
	self:addLuaEvent("PEAK_DUEL_DETAILS_HURT", self, self.onCheckDetailsHurt)

	self.itemList = Lua_DragList.new(self.content, 652, 720, Lua_AxisDefine.Vertical)
	self.itemList:setLocation(0, -90)
	self.itemList:setListCell(Lua_PeakDuelFightDetailsCell, 652, 435, 1)
end

function Lua_PeakDuelFightDetailsWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end

function Lua_PeakDuelFightDetailsWindow:showWin(param)
	self:superCall("showWin", param)
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sFightDetails(param.recordIdx, param.data.record_id)

	local role = param.data.attack_role.show_role
	self.leftName.text = LanUtil.formateStr(10066, role.server_prev, role.name)

	role = param.data.defence_role.show_role
	self.rightName.text = LanUtil.formateStr(10066, role.server_prev, role.name)
end

function Lua_PeakDuelFightDetailsWindow:onFightDetails(msg)
	self.resultText.text = LanUtil.formateStr(10050, tostring(msg.att_num), tostring(msg.def_num))

	local arr = Array()
	local data = msg.fight_report_info
	if #data > 1 then
		table.sort(data, function(a, b) return a.rotation < b.rotation end)
	end
	local canDrag = true
	for i = 1, 2 do
		if data and #data >= i then
			arr:add({ info = self.showData.data, data = data[i] })
		else
			canDrag = false
			arr:add({ info = self.showData.data, data = nil })
		end
	end
	self.itemList.customParam = self.showData.recordIdx
	self.itemList:setArrayData(arr)
	self.itemList.canDrag = canDrag
end

function Lua_PeakDuelFightDetailsWindow:onCheckDetailsHurt(recordId)
	if self.showData.recordIdx == 1 then
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(recordId, 3)
	else
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(recordId, 2)
	end
end













-- 录像列表
Lua_PeakDuelFightDetailsCell = class("Lua_PeakDuelFightDetailsCell", Lua_ListCell)
function Lua_PeakDuelFightDetailsCell:ctor(p)
	self:superCall("ctor", p,"PeakDuelFightDetailsCell_skin")
end

function Lua_PeakDuelFightDetailsCell:buildShowItem()
	self:superCall("buildShowItem")

	self.leftAvatar = Lua_AvatarItem.new(self.showObject)
	self.leftAvatar:setSiblingIndex(1)
	self.leftAvatar:setScale(0.4, 0.4, 1)
	self.leftAvatar:setLocation(-290, 140, 0)
	self.leftAvatar:setRoleAvatar(0)

	self.rightAvatar = Lua_AvatarItem.new(self.showObject)
	self.rightAvatar:setSiblingIndex(2)
	self.rightAvatar:setScale(0.4, 0.4, 1)
	self.rightAvatar:setLocation(290, 140, 0)
	self.rightAvatar:setRoleAvatar(0)

	self.leftPanel = Lua_HeroGridViewPanel.new(self.showObject)
	self.leftPanel:setLocation(-170, -35, 0)
	self.leftPanel:setLayout(1, 2)
	self.leftPanel:setGridCell(70, 70, Lua_PeakDuelFightDetailsGridItem)
	self.leftPanel:setCanClick(true)

	self.rightPanel = Lua_HeroGridViewPanel.new(self.rightObject)
	self.rightPanel:setLocation(170, -35, 0)
	self.rightPanel:setLayout(1, 0)
	self.rightPanel:setGridCell(70, 70, Lua_PeakDuelFightDetailsGridItem)
	self.rightPanel:setCanClick(true)

	self.noneText:setEnable(false)
	self.btnPlay:addClickFuntion(self, self.onPlay)
	self.checkHurt:addClickFuntion(self, self.onCheckHurt)
end

function Lua_PeakDuelFightDetailsCell:dispose()
	if self.leftAvatar then
		self.leftAvatar:dispose()
		self.leftAvatar = nil
	end
	if self.rightAvatar then
		self.rightAvatar:dispose()
		self.rightAvatar = nil
	end
	if self.leftPanel then
		self.leftPanel:dispose()
		self.leftPanel = nil
	end
	if self.rightPanel then
		self.rightPanel:dispose()
		self.rightPanel = nil
	end
	self.customParam = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_PeakDuelFightDetailsCell:setCustomParam(customParam)
	self.customParam = customParam
end

function Lua_PeakDuelFightDetailsCell:setData(data)
	self.data = data
	if data.data == nil then
		self.showObject:SetActive(false)
		self.noneText:setEnable(true)
	else
		self.showObject:SetActive(true)
		self.noneText:setEnable(false)

		local info = data.info
		local msg = data.data

		local maxRound = Lua_FightTemplateConfigData.getConfigData(Lua_FightDefine.TEMPLATE_ID_PEAKDUEL).maxRound
		self.show_round.text = LanUtil.formateStr(10044, tostring(msg.round), tostring(maxRound))

		if msg.win_id == 1 then
			self.left_result:setAltas("common_altas_4", "xui_jys_label_1")
			self.right_result:setAltas("common_altas_4", "xui_jys_label_2")
		else
			self.left_result:setAltas("common_altas_4", "xui_jys_label_2")
			self.right_result:setAltas("common_altas_4", "xui_jys_label_1")
		end

		self.match_time.text = os.date("%Y-%m-%d %H:%M", tonumber(info.fight_tick))

		self.left_team.text = LanUtil.formateStr(202955, tostring(msg.att_index))
		local role = info.attack_role.show_role
		self.leftAvatar:setRoleId(role.id, role.server_flag, info.attack_role.is_robot)
		self.leftAvatar:setRoleDressUp(role.dress_info)
		self.left_name.text = LanUtil.formateStr(10066, role.server_prev, role.name)

		self.left_force.text = msg.att_force
		self.leftPanel:setDataByProto(msg.att_lineup)

		self.left_bar:setMaxValue(100)
		self.left_bar:setValue(msg.att_health)
		self.left_bar:setText(LanUtil.formateStr(10057, tostring(msg.att_health)))

		self.right_team.text = LanUtil.formateStr(202955, tostring(msg.def_index))
		role = info.defence_role.show_role
		self.rightAvatar:setRoleId(role.id, role.server_flag, info.defence_role.is_robot)
		self.rightAvatar:setRoleDressUp(role.dress_info)
		self.right_name.text = LanUtil.formateStr(10066, role.server_prev, role.name)

		if msg.def_lineup and #msg.def_lineup > 0 then
			self.rightObject:SetActive(true)
			self.rightNoneText:setEnable(false)

			self.right_force.text = msg.def_force
			self.right_force:resetSize()
			self.rightForceIcon:setLocation(315 - self.right_force.width - 5, -193, 0)
			self.rightPanel:setDataByProto(msg.def_lineup)

			self.right_bar:setMaxValue(100)
			self.right_bar:setValue(msg.def_health)
			self.right_bar:setText(LanUtil.formateStr(10057, tostring(msg.def_health)))
		else
			self.rightObject:SetActive(false)
			self.rightNoneText:setEnable(true)
		end
	end
end

function Lua_PeakDuelFightDetailsCell:onPlay(go)
	if self.data == nil then
		return
	end
	local data = self.data.data
	if data == nil or data.def_lineup == nil and #data.def_lineup < 0 then
		OperateAlert.showLangValue(202971)
		return
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(data.record_id, 0, "", data.rotation, self.customParam)
end

function Lua_PeakDuelFightDetailsCell:onCheckHurt(go)
	if self.data == nil then
		return
	end	
	local data = self.data.data
	if data == nil or data.def_lineup == nil and #data.def_lineup < 0 then
		OperateAlert.showLangValue(202971)
		return
	end
	Lua_MsgUtil.callFunc("PEAK_DUEL_DETAILS_HURT", data.record_id)
end










Lua_PeakDuelFightDetailsGridItem = class("Lua_PeakDuelFightDetailsGridItem", Lua_HeroGridViewItem)
function Lua_PeakDuelFightDetailsGridItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_PeakDuelFightDetailsGridItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg:setScale(0.9, 0.9, 1)
end

function Lua_PeakDuelFightDetailsGridItem:setData(dataType, data)
	self:superCall("setData", dataType, data)
	if self.itemIcon then
		self.itemIcon:setScale(0.54, 0.54, 1)
	end
end