--巅峰战斗记录
Lua_PeakDuelFightRecordWindow = class("Lua_PeakDuelFightRecordWindow", Lua_Window)
function Lua_PeakDuelFightRecordWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_PeakDuelFightRecordWindow"
	self.skinName = "PeakDuelFightRecordWindow_skin"
    self.showBlackMask = true
    self.isClickClose = true
end

function Lua_PeakDuelFightRecordWindow:buildShowItem()
	self:superCall("buildShowItem")

    self:addLuaEvent("PEAK_DUEL_FIGHT_RECOR", self, self.showFightRecordInfo)
    self:addLuaEvent("PEAK_DUEL_RECORD", self, self.onCheckRecord)

    self.tabInfo = Array()
    self.tabInfo:add(202952)
    self.tabInfo:add(202953)

    self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
    self.buttonList:setLocation(0, -439, 0)
    self.buttonList:setButtonCell(Lua_CommonButtonItem2)
    self.buttonList:setButtonItem(160, 67)
    self.buttonList:setClickCallBack(self, self.onButtonClick)
    self.buttonList:setData(self.tabInfo)
    self.buttonList:setSelected(1)

    local segmentLvl = DataCenter.peakDuelData.segmentLvl
    local configData = DataCenter.peakDuelUtil:getSegmentInfoByid(segmentLvl)
    self.levelText.text = LanUtil.formateStr(202951, configData.name)
end

function Lua_PeakDuelFightRecordWindow:dispose()
    if self.buttonList then
        self.buttonList:dispose()
        self.buttonList = nil
    end
    if self.tabInfo then
        self.tabInfo:clear()
        self.tabInfo = nil
    end
    if self.itemList then
        self.itemList:dispose()
        self.itemList = nil
    end
    self:superCall("dispose")
end

function Lua_PeakDuelFightRecordWindow:onButtonClick(index, data)
    self.recordIdx = index
    Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDFightRecord(index)
end

function Lua_PeakDuelFightRecordWindow:showFightRecordInfo(msg)
    if msg.record_info == nil or #msg.record_info <= 0 then
        self:showNone(true)
        if self.itemList then
            self.itemList:setEnable(false)
        end
    else
        self:showNone(false)
        if self.itemList == nil then
            self.itemList = Lua_DragList.new(self.content, 630, 630, Lua_AxisDefine.Vertical)
            self.itemList:setLocation(0, -56, 0)
            self.itemList:setListCell(Lua_PeakDuelFightRecordCell, 630, 228, 1)
            self.itemList:setCellSpacing(0, 5)
        end
        self.itemList:setEnable(true)
        self.itemList:setArrayData(msg.record_info)
        self.itemList:moveToIndex(1, true)
    end
end

function Lua_PeakDuelFightRecordWindow:showNone(bValue)
    if bValue then
        if self.noneIcon == nil then
            self.noneIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_012", 0, -56, 0, 0)
            self.noneText = UICreate.createLabel(self.content, nil, 0, -87.5, 100, 40, 40)
            self.noneText.pivotValue = 4
            self.noneText.fontName = Lua_MyUISettings.huakangFontName
            self.noneText.alignmentValue = 4
            self.noneText.horizontalOverflowValue = 1
            self.noneText.colorStr = Lua_ColorDefine.transColorStr("938680")
            self.noneText:setLangValue(202954)
        end
        self.noneIcon:setEnable(true)
        self.noneText:setEnable(true)
    else
        if self.noneIcon then
            self.noneIcon:setEnable(false)
            self.noneText:setEnable(false)
        end
    end
end

function Lua_PeakDuelFightRecordWindow:onCheckRecord(data)
    Lua_WindowUtil.openWin("Lua_PeakDuelFightDetailsWindow", Lua_WinParam.ACTION_OPEN, { recordIdx = self.recordIdx, data = data })
end













-- 竞猜记录
Lua_PeakDuelFightRecordCell = class("Lua_PeakDuelFightRecordCell", Lua_ListCell)
function Lua_PeakDuelFightRecordCell:ctor(p)
    self:superCall("ctor", p, "PeakDuelFightRecordCell_skin")
end

function Lua_PeakDuelFightRecordCell:buildShowItem()
    self:superCall("buildShowItem")

    self.leftAvatar = Lua_AvatarItem.new(self.content)
    self.leftAvatar:setSiblingIndex(1)
    self.leftAvatar:setScale(0.6, 0.6, 1)
    self.leftAvatar:setLocation(-255, 55, 0)
    self.leftAvatar:setRoleAvatar(0)

    self.rightAvatar = Lua_AvatarItem.new(self.content)
    self.rightAvatar:setSiblingIndex(2)
    self.rightAvatar:setScale(0.6, 0.6, 1)
    self.rightAvatar:setLocation(255, 55, 0)
    self.rightAvatar:setRoleAvatar(0)

    self.checkDetails:addClickFuntion(self,self.onCheckDetails)
end

function Lua_PeakDuelFightRecordCell:dispose()
    if self.leftAvatar then
        self.leftAvatar:dispose()
        self.leftAvatar = nil
    end
    if self.rightAvatar then
        self.rightAvatar:dispose()
        self.rightAvatar = nil
    end
    self.data = nil
    self:superCall("dispose")
end

function Lua_PeakDuelFightRecordCell:setData(data)
    self.data = data

    if data.win_id == 1 then -- 1：攻方 2：守方
        self.left_result:setAltas("common_altas_4", "xui_jys_label_1")
        self.right_result:setAltas("common_altas_4", "xui_jys_label_2")
    else
        self.left_result:setAltas("common_altas_4", "xui_jys_label_2")
        self.right_result:setAltas("common_altas_4", "xui_jys_label_1")
    end

    local show_role = data.attack_role.show_role
    self.leftAvatar:setRoleId(show_role.id, show_role.server_flag, data.attack_role.is_robot)
    self.leftAvatar:setRoleDressUp(show_role.dress_info)

    self.left_server.text = LanUtil.formateStr(10047, show_role.server_prev)
    self.left_name.text = show_role.name
    self.left_rank.text = data.attack_role.rank
    self.left_lvl.text = show_role.level

    local config = DataCenter.peakDuelUtil:getSegmentInfoByid(data.attack_role.segment_lvl)
    self.left_icon:setAltas("peak_duel_altas", config.icon)

    show_role = data.defence_role.show_role
    self.rightAvatar:setRoleId(show_role.id, show_role.server_flag, data.defence_role.is_robot)
    self.rightAvatar:setRoleDressUp(show_role.dress_info)

    self.right_server.text = LanUtil.formateStr(10047, show_role.server_prev)
    self.right_name.text = show_role.name
    self.right_rank.text = data.defence_role.rank
    self.right_lvl.text = show_role.level

    config = DataCenter.peakDuelUtil:getSegmentInfoByid(data.defence_role.segment_lvl)
    self.right_icon:setAltas("peak_duel_altas", config.icon)

    self.matchTime.text = os.date("%Y-%m-%d %H:%M", tonumber(data.fight_tick))
end

function Lua_PeakDuelFightRecordCell:onCheckDetails()
    if self.data == nil then
        return
    end
    Lua_MsgUtil.callFunc("PEAK_DUEL_RECORD", self.data)
end