Lua_PeakDuelMatchPanel = class("Lua_PeakDuelMatchPanel", Lua_DisplayObject)
function Lua_PeakDuelMatchPanel:ctor(p, ownType)
	self.ownType = ownType
	self:superCall("ctor", p, "PeakDuelMatchPanel_skin")
end

function Lua_PeakDuelMatchPanel:buildShowItem()
	self:superCall("buildShowItem")

	self.lineupPanel_1 = Lua_HeroGridViewPanel.new(self.teamObject_1)
	self.lineupPanel_1:setCanClick(true)
	if self.ownType == Lua_FightDefine.FIGHT_ATTACKER then
		self.lineupPanel_1:setLayout(1, 0)
	else
		self.lineupPanel_1:setLayout(1, 2)
	end
	self.lineupPanel_1:setGridCell(75, 80)

	self.forceNum_1 = Lua_NumberImage.new(self.teamObject_1)
	self.forceNum_1:setLocation(-55, -177, 0)
	self.forceNum_1.pivot = 1
	self.forceNum_1.numOffsetX = -2
	self.forceNum_1.numAtlas = "number"
	self.forceNum_1.preStr = "xui_zl1_number_0"
end

function Lua_PeakDuelMatchPanel:dispose()
	if self.teamObject_1 then
		TweenUtil.getInstance():stop(self.teamObject_1)
	end
	if self.teamObject_2 then
		TweenUtil.getInstance():stop(self.teamObject_2)
	end
	if self.lineupPanel_1 then
		self.lineupPanel_1:dispose()
		self.lineupPanel_1 = nil
	end
	if self._forceNum_1 then
		self._forceNum_1:dispose()
		self._forceNum_1 = nil
	end
	if self._lineupPanel_2 then
		self._lineupPanel_2:dispose()
		self._lineupPanel_2 = nil
	end
	if self._forceNum_2 then
		self._forceNum_2:dispose()
		self._forceNum_2 = nil
	end
	self:superCall("dispose")
end

function Lua_PeakDuelMatchPanel.Get:lineupPanel_2()
	if self._lineupPanel_2 == nil then
		self._lineupPanel_2 = Lua_HeroGridViewPanel.new(self.teamObject_2)
		self._lineupPanel_2:setCanClick(true)
		if self.ownType == Lua_FightDefine.FIGHT_ATTACKER then
			self._lineupPanel_2:setLayout(1, 0)
		else
			self._lineupPanel_2:setLayout(1, 2)
		end
		self._lineupPanel_2:setGridCell(75, 80)
	end
	return self._lineupPanel_2
end

function Lua_PeakDuelMatchPanel.Get:forceNum_2()
	if self._forceNum_2 == nil then
		self._forceNum_2 = Lua_NumberImage.new(self.teamObject_2)
		self._forceNum_2:setLocation(83, -177, 0)
		self._forceNum_2.pivot = -1
		self._forceNum_2.numOffsetX = -2
		self._forceNum_2.numAtlas = "number"
		self._forceNum_2.preStr = "xui_zl1_number_0"
	end
	return self._forceNum_2
end

function Lua_PeakDuelMatchPanel:showTeam2(value)
	self.bShowTeam2 = value
end

function Lua_PeakDuelMatchPanel:setData_Defender(bTeam2, list)
	if list == nil or #list <= 0 then
		return
	end

	self.lineupPanel_1:setDataByProto(list[1].hero_list)

	if bTeam2 and #list > 1 and list[2].index > 0 then
		self.teamObject_1:SetActive(true)
		self.teamObject_2:SetActive(true)
		self.teamText_1.text = LanUtil.formateStr(202955, tostring(1))
		self.teamText_2.text = LanUtil.formateStr(202955, tostring(2))

		self.lineupPanel_1:setParent(self.teamObject_1)
		self.forceNum_1:setParent(self.teamObject_1)
		self.forceNum_1:setLocation(-55, -177, 0)
		self.forceNum_1.pivot = 1
		self.forceNum_1.num = list[1].force

		local info = DataCenter.heroLineupUtil:getStandInfoByType(list[1].stand_type)
		self.standIcon_1:setAltas("hero_embattle", info.stand_icon)

		self.lineupPanel_2:setDataByProto(list[2].hero_list)
		self.forceNum_2.num = list[2].force
		self.forceIcon_2:setLocation(83 - self.forceNum_2.totalWidth - 15, -177, 0)

		info = DataCenter.heroLineupUtil:getStandInfoByType(list[2].stand_type)
		self.standIcon_2:setAltas("hero_embattle", info.stand_icon)
	else
		self.teamObject_1:SetActive(false)
		self.teamObject_2:SetActive(true)
		self.teamText_2.text = LanUtil.formateStr(202955, tostring(1))
		
		self.lineupPanel_1:setParent(self.teamObject_2)
		self.forceNum_1:setParent(self.teamObject_2)
		self.forceNum_1:setLocation(83, -177, 0)
		self.forceNum_1.pivot = -1
		self.forceNum_1.num = list[1].force
		self.forceIcon_2:setLocation(83 - self.forceNum_1.totalWidth - 15, -177, 0)

		local info = DataCenter.heroLineupUtil:getStandInfoByType(list[1].stand_type)
		self.standIcon_2:setAltas("hero_embattle", info.stand_icon)
	end
end

function Lua_PeakDuelMatchPanel:setData_Attacker(bTeam2, lineupType)
	self.lineupPanel_1:setDataByLineupType(lineupType, 1)

	local vo = DataCenter.heroLineupData:getLineupVo(lineupType)
	local force = DataCenter.heroLineupData:calcLineupForce(lineupType, 1)
	self.forceNum_1.num = force

	local info = DataCenter.heroLineupUtil:getStandInfoByType(vo:getStandType(1))
	self.standIcon_1:setAltas("hero_embattle", info.stand_icon)

	if bTeam2 then
		self.teamObject_2:SetActive(true)
		self.lineupPanel_2:setDataByLineupType(lineupType, 2)

		force = DataCenter.heroLineupData:calcLineupForce(lineupType, 2)
		self.forceNum_2.num = force
		self.forceIcon_2:setLocation(83 - self.forceNum_2.totalWidth - 15, -177, 0)

		info = DataCenter.heroLineupUtil:getStandInfoByType(vo:getStandType(2))
		self.standIcon_2:setAltas("hero_embattle", info.stand_icon)
	else
		self.teamObject_2:SetActive(false)
	end
end

function Lua_PeakDuelMatchPanel:playEff_Defender(bTeam2)
	TweenUtil.getInstance():stop(self.teamObject_1)
	LuaUtil.setObjScale(self.teamObject_1, 0.1, 0.1, 0.1)
	TweenUtil.getInstance():addTweenTargetScale(self.teamObject_1, 0.15, 0, 1, 1, 1)
	
	TweenUtil.getInstance():stop(self.teamObject_2)
	if bTeam2 then
		LuaUtil.setObjScale(self.teamObject_2, 0.1, 0.1, 0.1)
		TweenUtil.getInstance():addTweenTargetScale(self.teamObject_2, 0.15, 0, 1, 1, 1)
	end
end