--巅峰对决匹配
checkRequire("Lua_PeakDuelMatchPanel")
Lua_PeakDuelMatchWindow = class("Lua_PeakDuelMatchWindow", Lua_Window)
function Lua_PeakDuelMatchWindow:ctor()
	self:superCall("ctor")

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_PeakDuelMatchWindow"
	self.skinName = "PeakDuelMatchWindow_skin"
	self.isFullSizeWin = true
	self.showWinBg = true
	self.winBgPath = "/images/peakDuel/xui_dfs_bg_3.jpg"
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG)
	self:addPreLoadRes("/images/peakDuel/xui_dfs_bg_1.png", Lua_LoadFileType.IMG)
	self:addPreLoadRes("/images/peakDuel/xui_dfs_bg_1_f.png", Lua_LoadFileType.IMG)
	self:addPreLoadRes("/images/peakDuel/xui_dfs_bg_2.png", Lua_LoadFileType.IMG)
	self:addPreLoadRes("/images/peakDuel/xui_dfs_bg_2_f.png", Lua_LoadFileType.IMG)
end

function Lua_PeakDuelMatchWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.bFristEnter = true

	self.playStep = 0
	self.lineupIdx = 1

	self:addLuaEvent("PEAK_DUEL_BUY_TIMES", self, self.updateTimes)
	self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.updateSelfLineup)
	self:addLuaEvent("PEAK_DUEL_MATCH", self, self.updateMatchInfo)

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
	self.roleInfoPanel:setRectAnchor(1)
	
	self.selfAvatar = Lua_AvatarItem.new(self.content)
	self.selfAvatar:setScale(0.4, 0.4, 1)
	self.selfAvatar:setLocation(325, 15, 0)

	self.cbModify.selected = DataCenter.roleData:getOperationRecord("peak_duel_skip_lineup") == 1
	self.cbModify:addBoxChange(self, self.onModifyChange)

	self.timesAdd:addClickFuntion(self, self.onBuyMatchTimes)
	self.btnLineup:addClickFuntion(self, self.onLineupClick)
	self.btnFight:addClickFuntion(self, self.onFightClick)

	self:updateShowInfo()
	self:updateTimes()
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDMatchInfo()
end

function Lua_PeakDuelMatchWindow:dispose()
	self:stopTimer()
	Lua_CommonUtil.removeTimer(self, self.onDelayEnd)
	if self.enemyPic then
		TweenUtil.getInstance():stop(self.enemyPic.mainContent)
	end
	if self.bMatching == true then
		self:onMatch()
	end
	DataCenter.preLoadData:removeBySign("Lua_PeakDuelLineupWindow", self, self.onSceneShow)
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	if self.selfAvatar then
		self.selfAvatar:dispose()
		self.selfAvatar = nil
	end
	if self.rivalAvatar then
		self.rivalAvatar:dispose()
		self.rivalAvatar = nil
	end
	if self.myMatchPanel then
		self.myMatchPanel:dispose()
		self.myMatchPanel = nil
	end
	if self.rivalMatchPanel then
		self.rivalMatchPanel:dispose()
		self.rivalMatchPanel = nil
	end
	if self.uiEff then
		self.uiEff:dispose()
		self.uiEff = nil
	end
	self:superCall("dispose")
end

function Lua_PeakDuelMatchWindow:onModifyChange(state)
	if state == true then
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("peak_duel_skip_lineup", 1)
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("peak_duel_skip_lineup", 0)
	end
end

function Lua_PeakDuelMatchWindow:updateShowInfo()
	local roleData = DataCenter.roleData
	local avatarId = roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD)
	local frameId = roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_FRAME)
	
	self.selfName.text = LanUtil.formateStr(10047, roleData.server_prev)..roleData.name
	self.selfAvatar:setRoleAvatar(avatarId)
	self.selfAvatar:setRoleVip(roleData.vip)
	self.selfAvatar:setRoleFrame(frameId)
	
	local segmentLvl = DataCenter.peakDuelData.segmentLvl
	local config = DataCenter.peakDuelUtil:getSegmentInfoByid(segmentLvl)
	self.selfLvIcon:setAltas("peak_duel_altas", config.icon)
	self.selfLevel.text = config.name

	self.bSatisfySegment = config.team_num > 1
	self:updateSelfLineup()
end

function Lua_PeakDuelMatchWindow:updateTimes()
	local left_buy_times = DataCenter.peakDuelData.left_buy_times
	local left_match_times = DataCenter.peakDuelData.left_match_times
	local match_times = DataCenter.peakDuelUtil.match_times

	self.timesAdd:setGray(left_buy_times == 0)
	self.timesAdd.mouseEnable = left_buy_times > 0
	
	self.timesText.text = LanUtil.formateStr(202913, tostring(left_match_times), tostring(match_times))
	self.buyTimesText.text = LanUtil.formateStr(202914, tostring(left_buy_times))
end

function Lua_PeakDuelMatchWindow:updateSelfLineup()
	if self.bSatisfySegment then
		self.selfPic:setEnable(false)
	else
		self.selfPic:setEnable(true)
		local avatarId = DataCenter.roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD)
		local vo = DataCenter.roleUtil:getDressUpVoById(avatarId)
		self.selfPic:setUrl(vo.halfPicUrl)
	end
	if self.myMatchPanel == nil then
		self.myMatchPanel = Lua_PeakDuelMatchPanel.new(self.content, Lua_FightDefine.FIGHT_ATTACKER)
		self.myMatchPanel:setLocation(0, -148, 0)
	end
	self.myMatchPanel:setData_Attacker(self.bSatisfySegment, Lua_HeroUtil.LINEUP_PEAKDUEL)
end

function Lua_PeakDuelMatchWindow:updateMatchInfo(msg)
	if DataCenter.peakDuelData.match_result == 0 then
		self.cbModify:setEnable(true)
		self.btnFight:setLangValue(202982)
		self.countDownText:setEnable(false)

		self:stopTimer()
		self.promptText:setEnable(true)
		self:updateRivalLineup(nil)
	else
		self.cbModify:setEnable(false)
		self.btnFight:setLangValue(202983)

		self.waitTime = tonumber(msg.match_info.fight_start_tick)
		self.leftSecond = self.waitTime - DataCenter.roleData.serverTime
		if self.leftSecond > 0 then
			self.countDownText:setEnable(true)
			self:startTimer()
			self:onTimer()
		else
			self:stopTimer()
		end
		self.promptText:setEnable(false)
		self:updateRivalLineup(msg.match_info, msg.is_robot, true)
	end
	self.bFristEnter = false
end

function Lua_PeakDuelMatchWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true
		self:addTimer("Lua_PeakDuelMatchWindow", 1, self, self.onTimer)
	end
end

function Lua_PeakDuelMatchWindow:stopTimer()
	if self.bTimer == true then
		self.bTimer = false
		self:removeTimer(self, self.onTimer)
	end
end

function Lua_PeakDuelMatchWindow:onTimer()
	self.leftSecond = self.waitTime - DataCenter.roleData.serverTime
	if self.leftSecond > 0 then
		self.countDownText.text = LanUtil.formateStr(202981, tostring(self.leftSecond))
	else
		self:stopTimer()
		self.countDownText:setEnable(false)
	end
end

function Lua_PeakDuelMatchWindow:updateRivalLineup(info, is_robot, bPlayEff)
	if info == nil or info.show_role == nil or tonumber(info.show_role.id) <= 0 then
		self.enemyPic:setUrl("/images/peakDuel/xui_dfs_widget_14.png")
		self.enemyPic:setLocation(0, 222, 0)
		self.enemyPic:SetDimensions(411, 353)
		self.enemyPic:setScale(1, 1, 1)

		self.enemyObject:SetActive(false)
		self.noneIcon:setEnable(true)
	else
		self.noneIcon:setEnable(false)
		self.enemyName.text = LanUtil.formateStr(10047, info.show_role.server_prev)..info.show_role.name

		if self.rivalAvatar == nil then
			self.rivalAvatar = Lua_AvatarItem.new(self.enemyObject)
			self.rivalAvatar:setScale(0.4, 0.4, 1)
			self.rivalAvatar:setLocation(-325, 410.5, 0)
		end
		self.rivalAvatar:setRoleId(info.show_role.id, info.show_role.server_flag, is_robot)
		self.rivalAvatar:setRoleDressUp(info.show_role.dress_info, is_robot)
		self.rivalAvatar:setRoleVip(info.show_role.vip)

		local config = DataCenter.peakDuelUtil:getSegmentInfoByid(info.segment_lvl)
		self.enemyLvIcon:setAltas("peak_duel_altas", config.icon)
		self.enemyLevel.text = config.name

		if self.rivalMatchPanel == nil then
			self.rivalMatchPanel = Lua_PeakDuelMatchPanel.new(self.enemyObject, Lua_FightDefine.FIGHT_DEFENDER)
			self.rivalMatchPanel:setLocation(0, 250, 0)
		end
		self.rivalMatchPanel:setData_Defender(self.bSatisfySegment, info.lineup)

		if self.bSatisfySegment and (config.team_num == nil or config.team_num <= 1) then
			self.bSatisfySegment = false
			self:updateSelfLineup()
		end

		if self.bSatisfySegment then
			self.enemyPic:setEnable(false)
			if self.bFristEnter then
				self.enemyObject:SetActive(true)
			else
				self.playStep = 2
				self:showEff("ui_dfdj_pp_02")
				self:onDelayEnd()
			end
		else
			local avatarId = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD, info.show_role.dress_info)
			local vo = DataCenter.roleUtil:getDressUpVoById(avatarId)
			self.enemyPic:setUrl(vo.halfPicUrl)
			self.enemyPic:SetDimensions(900, 546)
			self.enemyPic:setScale(0.86, 0.86, 1)
			self.enemyPic:setEnable(true)

			if self.bFristEnter then
				self.enemyPic:setLocation(-151, 280, 0)
				self.enemyObject:SetActive(true)
			else
				self.playStep = 2
				self:onDelay(0.3)
				TweenUtil.getInstance():stop(self.enemyPic.mainContent)
				self.enemyPic:setLocation(720, 280, 0)
				TweenUtil.getInstance():addTweenTargetPos(self.enemyPic.mainContent, 0.3, 0, 0, 280, 0)
				TweenUtil.getInstance():addTweenTargetPos(self.enemyPic.mainContent, 0.3, 0.6, -151, 280, 0)
			end
		end
	end
end

function Lua_PeakDuelMatchWindow:onBuyMatchTimes(go)
	local buy_time = DataCenter.peakDuelData.buy_times
	local config = DataCenter.peakDuelUtil:getMatchTimesConfig(buy_time + 1)
	self.matchTimesCost = config.json_value

	local tipsData = {
		des = LanUtil.formateStr(202915, self.matchTimesCost[1][2]), btnType = 1, owner = self, sureFun = self.onSureBuyMatch
	}
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_PeakDuelMatchWindow:onSureBuyMatch()
	local costId = DataCenter.packData:checkConsumeEnough(self.matchTimesCost)
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDBuyTimes()
	else
		DataCenter.packUtil:openPathWindow(costId, false)
	end
end

function Lua_PeakDuelMatchWindow:onLineupClick(go)
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_PEAKDUEL)
	DataCenter.preLoadData:preShowScene("Lua_PeakDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0)
end

function Lua_PeakDuelMatchWindow:onSceneShow(param, mp, success)
	if not success then return; end
	Lua_WindowUtil.openWin("Lua_PeakDuelLineupWindow", Lua_WinParam.ACTION_OPEN, self.lineupIdx)
	self.lineupIdx = 1
end

function Lua_PeakDuelMatchWindow:onFightClick(go)
	if DataCenter.peakDuelData.match_result == 0 then
		local left_match_times = DataCenter.peakDuelData.left_match_times
		if left_match_times <= 0 then
			if DataCenter.peakDuelData.left_buy_times > 0 then
				self:onBuyMatchTimes()
			else
				OperateAlert.showLangValue(720000)
			end
			return
		end

		if self.bSatisfySegment then
			local num = DataCenter.heroLineupData:getLineupHeroNum(Lua_HeroUtil.LINEUP_PEAKDUEL, 2)
			if num > 0 then
				self:onPlayEff()
			else
				self.lineupIdx = 2
				local tipsData = { des = 202997, btnType = 1, sureLabel = 202998, owner = self, sureFun = self.onLineupClick }
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
			end
		else
			self:onPlayEff()
		end
	else
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_PEAKDUEL)
	end
end

function Lua_PeakDuelMatchWindow:onPlayEff()
	if self.bMatching == true then
		return
	end
	self.bMatching = true
	self:showEff("ui_dfdj_pp_01")
end

function Lua_PeakDuelMatchWindow:showEff(str)
	if self.uiEff == nil then
		self.uiEff = UICreate.createUIEffect(self.content, nil, nil, 0, 280)
		self.uiEff.siblingIndex = self.enemyPic.siblingIndex + 1
	end
	self.uiEff:setEnable(true)
	if str == "ui_dfdj_pp_01" then
		self.uiEff:addLuaLoadCompleteFun(self, self.onEffLoaded)
	else
		self.uiEff:removeLuaLoadCompleteFun(self, self.onEffLoaded)
	end
	self.uiEff:setUrl("/effects/uiEffects/"..str, str)
end

function Lua_PeakDuelMatchWindow:onEffLoaded()
	self.playStep = 1
	self.enemyPic:setEnable(false)
	self.noneIcon:setEnable(false)
	self:onDelay(3)
end

function Lua_PeakDuelMatchWindow:onDelay(value)
	Lua_CommonUtil.removeTimer(self, self.onDelayEnd)
	Lua_CommonUtil.delayCall(value, self, self.onDelayEnd)
end

function Lua_PeakDuelMatchWindow:onDelayEnd()
	if self.playStep == 1 then
		self.uiEff:setEnable(false)
		self:onMatch()
	else
		if self.bSatisfySegment then
			if self.playStep == 2 then
				self.enemyObject:SetActive(true)
				self.rivalMatchPanel:playEff_Defender(true)
			end
		else
			if self.playStep == 2 then
				self:showEff("ui_dfdj_pp_02")
				self.playStep = 3
				self:onDelay(0.3)
			elseif self.playStep == 3 then
				self.enemyObject:SetActive(true)
				self.rivalMatchPanel:playEff_Defender()
			end
		end
	end
end

function Lua_PeakDuelMatchWindow:onMatch()
	if self.bMatch == true then
		return
	end
	self.bMatch = true
	local isSkip = DataCenter.roleData:getOperationRecord("peak_duel_skip_lineup")
	Lua_ProxyManager.getProxy("Lua_PeakDuelProxy"):sPDMatch(isSkip)
end