--巅峰对决
checkRequire("Lua_PeakDuelMySchedulePanel")
checkRequire("Lua_PeakDuelGuessPanel")
checkRequire("Lua_PeakDuelRankPanel")
Lua_PeakDuelWindow = class("Lua_PeakDuelWindow", Lua_Window)
function Lua_PeakDuelWindow:ctor()
	self:superCall("ctor")

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_PeakDuelWindow"
	self.isFullSizeWin = true
	self.isSingleShowWin = true
	self.winBgPath = "/images/peakDuel/xui_dfs_bg_3.jpg"
	self.showWinBg = true
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG)
end

function Lua_PeakDuelWindow:buildShowItem()
	self:superCall("buildShowItem")
	self:addLuaEvent("PEAK_DUEL_INFO", self, self.showModel)
	self:addLuaEvent("UPDATE_DRESSUP_INFO", self, self.showModel)

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
	self.roleInfoPanel:setRectAnchor(1)

	self.btnBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60.5, 720, 121)
	self.btnBg.anchorValue = 7

	self.btnInfo = Array()
	self.btnInfo:add({ textAtlas = "peak_duel_altas", textNormalSprite = "xui_dfs_zgnbutton_2_n", textSelectedSprite = "xui_dfs_zgnbutton_2_p",
		panel = Lua_PeakDuelMySchedulePanel, redPointId = nil })
	self.btnInfo:add({ textAtlas = "peak_duel_altas", textNormalSprite = "xui_dfs_zgnbutton_3_n", textSelectedSprite = "xui_dfs_zgnbutton_3_p",
		panel = Lua_PeakDuelGuessPanel, redPointId = Lua_RedPointList.PeakDuel_Guess })
	self.btnInfo:add({ textAtlas = "peak_duel_altas", textNormalSprite = "xui_dfs_zgnbutton_1_n", textSelectedSprite = "xui_dfs_zgnbutton_1_p",
		panel = Lua_PeakDuelRankPanel, redPointId = Lua_RedPointList.PeakDuel_Like })

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
    self.btnList:setRectAnchor(7)
    self.btnList:setRectPivot(5)
    self.btnList.pivot = -1
    self.btnList:setLocation(360, 53.5, 0)
    self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1)
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1)
    self.btnList:setButtonItem(120, 108)
    self.btnList:setRedPoint(40, 40)
    self.btnList:setClickCallBack(self, self.onButtonClick)
    self.btnList:setData(self.btnInfo)
    self.btnList:setSelected(1)

    self:createBackBtn()
end

function Lua_PeakDuelWindow:dispose()
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	if self.showPanel then
		self.showPanel:dispose()
		self.showPanel = nil
	end
	if self.btnList then
		self.btnList:dispose()
		self.btnList = nil
	end
	if self.btnInfo then
		self.btnInfo:clear()
		self.btnInfo = nil
	end
	self:disposeModel()
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self:superCall("dispose")
end

function Lua_PeakDuelWindow:onBackBtnClick(go)
	self:superCall("onBackBtnClick", go)
	DataCenter.funcPathUtil:gotoFunction(1038, true)
end

function Lua_PeakDuelWindow:showWin(param)
	self:superCall("showWin", param);
	if Lua_WindowUtil.isOpenWin("Lua_PeakDuelMatchWindow") then
		Lua_WindowUtil.openWin("Lua_PeakDuelMatchWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_PeakDuelWindow:resetActive(bActive)
	self:superCall("resetActive", bActive)
	if bActive then
		self:showModel(true)
	else
		self:disposeModel()
	end
end

function Lua_PeakDuelWindow:onButtonClick(index, data)
	self.winBg:setEnable(true)
	if self.showPanel then
		self.showPanel:dispose()
		self.showPanel = nil
	end
	self.showPanel = data.panel.new(self.content)
	self.showPanel:setSiblingIndex(1)
	self.showPanel:setRectAnchor(9)

	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	if index ~= 3 then
		self.tweenName = DataCenter.winTweenManager:createWinTween(self.showPanel.classname, self.windowObj.transform);
	end
end

function Lua_PeakDuelWindow:showModel(value)
	if Lua_WindowUtil.isWindowShowing("Lua_PeakDuelLineupWindow") and value ~= true then
		return;
	end

	if DataCenter.peakDuelData.is_off_season == 0 then
		self.winBg:setEnable(true)
		self:disposeModel()
		return
	end

	if self.winBg then
		self.winBg:setEnable(false)
	end
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_MultiModelScenePanel.new()
		self.modelScenePanel:showModelScene(Lua_SceneDefine.PEAK_DUEL)
	end

	local list = DataCenter.peakDuelData.top_three_role
	local modelDic = {{0, 0, 0.3}, {1.4, 0, -0.8}, {-1.4, 0, -0.8}};
	for i = 1, 3 do
		if list and #list >= i then
			if DataCenter.roleData:isMyself(list[i].show_role.id) then
				data = DataCenter.roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_MODEL)
			else
				data = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_MODEL, list[i].show_role.dress_info)
			end
			data = DataCenter.roleUtil:getDressUpVoById(data)
			if data then
				if data.bShowFur then
					DataCenter.sceneUtil:setSceneDataExtendVal(self.windowName, "FurEffShow", true);
				end
				self.modelScenePanel:addSingleModel(i, data.uiModelUrl, data.uiModelAvatarName, nil, data.uiModelDir, 1, modelDic[i], true)
			end
		end
	end
end

function Lua_PeakDuelWindow:disposeModel()
	DataCenter.sceneUtil:setSceneDataExtendVal(self.windowName, "FurEffShow", false);
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
end